#   XMLOutStream: Tranform a tree of element objects into an XML document.
#   Copyright (C) 1999  Daniel Arbuckle
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    
#    Daniel Arbuckle can be contacted by email at djarb@wvc-omak.ctc.edu

from Element import Element

XMLHEADER='<?xml version="1.0" standalone="yes"?>\n'

class XMLOutStream:
    def __init__(self, sock, pretty = 0):
	self.debug = None
        self.__sock = sock #Output socket
        self.__pretty = pretty #Flag for pretty printing
        self.__sock.send(XMLHEADER) #Output the XML header line
    
    def send_arbitrary(self, str):
        "Transmits an arbitrary string through the stream. USE WITH CAUTION."
        self.__sock.send(str)
        if(self.debug):
            self.debug.send(str)
        
    def put_next(self, element):
        #Do I want to set the socket to blocking mode for this method?
        if self.__pretty:
            element.output(self.__sock, 0) #Print starting at nesting 0
            if self.debug: element.output(self.debug, 0)
        else:
            element.output(self.__sock, -1) #Print without pretty printing
            if self.debug: element.output(self.debug, -1)
